DEFINT A-Z
'$INCLUDE: 'COMMON.BI'
'$INCLUDE: 'DIRECTQB.BI'

REM $DYNAMIC
FUNCTION DirX (DirSpec$, Filter%, SearchType%)

DIM Registers AS RegTypeX

IF SearchType <> FINDFIRST AND SearchType <> FINDNEXT THEN EXIT FUNCTION
IF SearchType = FINDFIRST THEN
	Registers.ax = &H1A00
	Registers.ds = VARSEG(DTA)
	Registers.Dx = VARPTR(DTA)
	CALL INTERRUPTX(&H21, Registers, Registers)
END IF

DirSpec$ = DirSpec$ + CHR$(0)
Registers.ax = SearchType
Registers.cx = 22
Registers.ds = VARSEG(DirSpec$)
Registers.Dx = SADD(DirSpec$)
CALL INTERRUPTX(&H21, Registers, Registers)

IF Registers.flags AND 1 THEN
	DirX = NOTMOREFOUND
	EXIT FUNCTION
END IF

Result = TRUE
SELECT CASE Filter
	CASE FILESONLY
		IF DTA.Attributes = 4096 THEN Result = FALSE
	CASE DIRSONLY
		IF DTA.Attributes <> 4096 THEN Result = FALSE
END SELECT

IF Result THEN
	NullByte = INSTR(DTA.FileName, CHR$(0))
	IF NullByte > 0 THEN
		DTA.FileName = LEFT$(DTA.FileName, NullByte - 1) + SPACE$(14 - NullByte)
	END IF
		DirX = ENTRYFOUND
ELSE
		DirX = ENTRYNOTMATCHEDFILTER
END IF

END FUNCTION

SUB DQBsbox (Layer, X1, Y1, X2, Y2, Col)

Px1 = X1: Py1 = Y1
Px2 = X2: Py2 = Y2
IF Px2 < Px1 THEN SWAP Px1, Px2
IF Py2 < Py1 THEN SWAP Py1, Py2

IF Px1 < 0 THEN Px1 = 0
IF Py1 < 0 THEN Py1 = 0
IF Px2 > 319 THEN Px2 = 319
IF Py2 > 199 THEN Py2 = 199

DQBbox Layer, Px1, Py1, Px2, Py2, Col

END SUB

REM $STATIC
SUB DrawCursor (Layer, Col)

DQBline Layer, DQBmouseX - 5, DQBmouseY, DQBmouseX - 1, DQBmouseY, Col
DQBline Layer, DQBmouseX + 5, DQBmouseY, DQBmouseX + 1, DQBmouseY, Col
DQBline Layer, DQBmouseX, DQBmouseY - 5, DQBmouseX, DQBmouseY - 1, Col
DQBline Layer, DQBmouseX, DQBmouseY + 5, DQBmouseX, DQBmouseY + 1, Col

END SUB

REM $DYNAMIC
FUNCTION FileNotFound (FileName$)

DIM Inregs AS RegTypeX, Outregs AS RegTypeX

FileToCheck$ = FileName$ + CHR$(0)

Inregs.ax = &H4300
Inregs.ds = VARSEG(FileToCheck$)
Inregs.Dx = SADD(FileToCheck$)
CALL INTERRUPTX(&H21, Inregs, Outregs)

IF Outregs.flags AND 1 THEN FileNotFound = -1

END FUNCTION

FUNCTION FileSelect$ (FileSpec$, FileType$, Dialog$, WorkLayer, BackLayer)

' This is an all purpose file selector specifically designed for 4x6 fonts.
' Bigger fonts won't work properly with this.

DIM FileNames$(256)
'$INCLUDE: 'COLORS.BI'

Result = DirX(FileSpec$, FILESONLY, FINDFIRST)
IF Result = NOTMOREFOUND THEN
	DQBboxf VIDEO, 98, 95, 220, 103, 0
	DQBbox VIDEO, 98, 95, 220, 103, CHWHITE
	DQBprint VIDEO, "No " + FileType$ + " files found", CENTERED, 97, CHWHITE
	WHILE INKEY$ = "": WEND
	EXIT FUNCTION
END IF
IF Result = ENTRYFOUND THEN
	NameIndex = 1
	FileNames$(NameIndex) = RTRIM$(DTA.FileName)
END IF
FOR GetFiles = 1 TO 255
	Result = DirX(FileSpec$, FILESONLY, FINDNEXT)
	IF Result = NOTMOREFOUND THEN EXIT FOR
	IF Result = ENTRYFOUND THEN
		NameIndex = NameIndex + 1
		FileNames$(NameIndex) = RTRIM$(DTA.FileName)
	END IF
NEXT GetFiles
FileCount = NameIndex

Vy = 0
DQBcopyLayer WorkLayer, BackLayer ' Back-up old layer

DO
	Press$ = UCASE$(INKEY$)

	DQBcopyLayer BackLayer, WorkLayer
	DQBboxf WorkLayer, 130, 60, 190, 140, 0
	DQBbox WorkLayer, 130, 60, 190, 140, CHWHITE
	DQBline WorkLayer, 130, 68, 190, 68, CHWHITE
	DQBline WorkLayer, 180, 68, 180, 140, CHWHITE
	DQBprint WorkLayer, Dialog$, CENTERED, 62, CHWHITE

	IF FileCount > 1 THEN ScrollBarY = 69 + (70 * SelFile \ FileCount) ELSE ScrollBarY = 69
	DQBline WorkLayer, 181, ScrollBarY, 189, ScrollBarY, CYELLOW

	Ly = 70 - Vy
	DQBsetClipBox 131, 70, 188, 138
	FOR DrawList = 1 TO FileCount
		TextCol = CHWHITE
		IF Ly > 64 AND Ly < 188 THEN
			IF DrawList = SelFile THEN TextCol = CYELLOW
			DQBprint WorkLayer, FileNames$(DrawList), 132, Ly, TextCol
		END IF
		Ly = Ly + 6
	NEXT DrawList
	DQBsetClipBox 0, 0, 319, 199

	SelPos = 6 * SelFile
	FOR Scroll = 1 TO 40
		IF SelPos > (Vy + 4 * Scroll) + 40 AND Vy < (6 * FileCount) - 70 THEN Vy = Vy + 1
		IF SelPos < (Vy - 4 * Scroll) + 40 AND Vy > 0 THEN Vy = Vy - 1
	NEXT Scroll

	IF Press$ = CHR$(0) + "H" THEN SelFile = SelFile - 1
	IF Press$ = CHR$(0) + "P" THEN SelFile = SelFile + 1
	IF Press$ = CHR$(0) + "Q" THEN SelFile = SelFile + 5
	IF Press$ = CHR$(0) + "I" THEN SelFile = SelFile - 5
	IF Press$ = CHR$(0) + "G" THEN SelFile = 1
	IF Press$ = CHR$(0) + "O" THEN SelFile = FileCount
	IF Press$ = CHR$(27) THEN EXIT FUNCTION
	IF SelFile < 1 THEN SelFile = 1
	IF SelFile > FileCount THEN SelFile = FileCount

	DQBcopyLayer WorkLayer, VIDEO
	DQBwait 1

LOOP UNTIL Press$ = CHR$(13)
FileSelect$ = FileNames$(SelFile)

END FUNCTION

FUNCTION InputBox$ (Msg$, Valid$, Txt$, MaxLen, WorkLayer, BackLayer, UCased)

' This is an all purpose input box specifically designed for 4x7 fonts. Bigger
' fonts don't work correctly with this.

'$INCLUDE: 'COLORS.BI'

WinWidth = (DQBlen(Msg$) \ 2) + 4
WordWidth = ((4 * MaxLen) \ 2) + 4
IF WordWidth > WinWidth THEN WinWidth = WordWidth

DQBcopyLayer WorkLayer, BackLayer
Cur$ = " "
DO
	IF UCased THEN Press$ = UCASE$(INKEY$) ELSE Press$ = INKEY$
	DQBcopyLayer BackLayer, WorkLayer

	DQBboxf WorkLayer, 160 - WinWidth, 92, 160 + (WinWidth - 2), 108, 0
	DQBbox WorkLayer, 160 - WinWidth, 92, 160 + (WinWidth - 2), 108, CHWHITE
	DQBline WorkLayer, 160 - WinWidth, 100, 160 + (WinWidth - 2), 100, CHWHITE
  
	DQBprint WorkLayer, Msg$, CENTERED, 94, CHWHITE
	DQBprint WorkLayer, Txt$ + Cur$, CENTERED, 102, CHWHITE

	IF Press$ <> "" THEN
		IF INSTR(Valid$, Press$) AND LEN(Txt$) < MaxLen THEN Txt$ = Txt$ + Press$
		IF Press$ = CHR$(8) AND LEN(Txt$) > 0 THEN Txt$ = LEFT$(Txt$, LEN(Txt$) - 1)
	END IF
  
	DQBcopyLayer WorkLayer, VIDEO
	DQBwait 1

	Cnt = Cnt + 1
	IF Cnt = 10 THEN Cnt = 1: Cur = Cur + 1 AND 1
	IF Cur THEN Cur$ = "_" ELSE Cur$ = " "
	IF Press$ = CHR$(27) THEN EXIT FUNCTION
LOOP UNTIL Press$ = CHR$(13)
InputBox$ = Txt$

END FUNCTION

SUB Msgbox (Layer, Msg$)
'$INCLUDE: 'COLORS.BI'

WinWidth = (DQBlen(Msg$) \ 2) + 4
DQBboxf Layer, 160 - WinWidth, 95, 160 + (WinWidth - 2), 103, 0
DQBbox Layer, 160 - WinWidth, 95, 160 + (WinWidth - 2), 103, CHWHITE
DQBprint Layer, Msg$, CENTERED, 97, CHWHITE

END SUB

REM $STATIC
SUB xBox (Layer, X1, Y1, X2, Y2)

Px1 = x1: Py1 = y1
Px2 = x2: Py2 = y2
IF Px2 < Px1 THEN SWAP Px1, Px2
IF Py2 < Py1 THEN SWAP Py1, Py2

IF Px1 < 0 THEN Px1 = 0
IF Py1 < 0 THEN Py1 = 0
IF Px2 > 319 THEN Px2 = 319
IF Py2 > 199 THEN Py2 = 199

FOR Px = Px1 + 1 TO Px2 - 1
	DQBpset Layer, Px, Py1, DQBpoint(Layer, Px, Py1) XOR 255
	DQBpset Layer, Px, Py2, DQBpoint(Layer, Px, Py2) XOR 255
NEXT Px
FOR Py = Py1 TO Py2
	DQBpset Layer, Px1, Py, DQBpoint(Layer, Px1, Py) XOR 255
	DQBpset Layer, Px2, Py, DQBpoint(Layer, Px2, Py) XOR 255
NEXT Py

END SUB

