DEFINT A-Z
'$DYNAMIC
'$INCLUDE: 'COMMON.BI'
'$INCLUDE: 'DIRECTQB.BI'

' Sub/function declarations
DECLARE FUNCTION ShiftState% ()
DECLARE SUB SetPixel (X%, Y%, Col%)
DECLARE SUB SetAnim (Anim%, AnmF%, Tile%)
DECLARE SUB GetAnim (Anim%, AnmF%, Tile%)
DECLARE SUB DrawPointer (Layer%, X%, Y%, Size%)
DECLARE SUB GetFlags (HitFlag%, DrwFlag%, Tile%)
DECLARE SUB SetFlags (HitFlag%, DrwFlag%, Tile%)
DECLARE FUNCTION GetPixel% (X%, Y%)

' Defined variables
DIM AnimePal AS STRING * 768
DIM ImagePal AS STRING * 768

' Data arrays
TileSize = DQBsize(1, 1, 24, 24)
DIM SHARED Tile(TileSize \ 2)
DIM SHARED TileFlag(255)
DIM SHARED TileAnim(255)
DIM Test(TileSize \ 2)
DIM SBuf(TileSize \ 2)
DIM AnimRate(255)
DIM Temp(25, 25)
DIM RGBval(1 TO 3, 1 TO 16)

' Check files and stuff
IF FileNotFound("BRICKS.PCX") THEN PRINT "I cannot load bricks.pcx!": Fail = TRUE
IF FileNotFound("ANIMEPAL.PAL") THEN PRINT "I cannot load animepal.pal!": Fail = TRUE
IF FileNotFound("MICRO.FNT") THEN PRINT "I cannot load micro.fnt!": Fail = TRUE
IF Fail THEN WHILE INKEY$ = "": WEND: END

' Init stuff
RANDOMIZE TIMER
IF DQBinit(3, 0, 145) THEN PRINT DQBerror$: END
IF NOT DQBmouseDetected THEN
	PRINT "Microsoft compatible mouse is required."
	GOTO EndIt
END IF
DQBfpu

' Set screen and load stuff
DQBinitVGA
DQBresetMouse
'$INCLUDE: 'LOADPAL.BI'
DQBgetPal AnimePal
'$INCLUDE: 'COLORS.BI'
DQBprint VIDEO, "Loading...", 1, 1, CHWHITE
Crap = DQBloadImage(3, 0, 0, "BRICKS.PCX", ImagePal, 0, 0)
Crap = DQBloadFont("MICRO.FNT")

' Prepare EMS memory for tile data
Tile(0) = 24 * 8: Tile(1) = 24
FOR P = 0 TO 255: DQBpoke VARSEG(Tile(0)), VARPTR(Tile(0)), CLNG(TileSize) * P, TileSize: NEXT P

Grid = 0
CurX = 12
CurY = 12
CurCol = 15
CurTile = 0
ControlMode = 1

MainLoop:
DO
	Press$ = UCASE$(INKEY$)

	' Draw color palette
	DQBcopyLayer 3, 1
	Col = 0
	FOR Dx = 1 TO 16
		FOR Dy = 1 TO 16
			IF Col THEN DQBboxf 1, 220 + (Dx + (3 * (Dx - 1))), 50 + (Dy + (3 * (Dy - 1))), 220 + ((Dx + (3 * (Dx - 1))) + 3), 50 + ((Dy + (3 * (Dy - 1))) + 3), Col
			IF Col = CurCol THEN DrawPointer 1, 220 + (Dx + (3 * (Dx - 1))), 50 + (Dy + (3 * (Dy - 1))), 4
			Col = Col + 1
		NEXT Dy
	NEXT Dx
	DQBbox 1, 220, 50, 285, 115, CHWHITE

	' Draw tile
	DEF SEG = VARSEG(Tile(2))
	FOR Dy = 1 TO 24
		FOR Dx = 1 TO 24
			Offset = (Dx - 1) + 24 * (Dy - 1)
			Col = PEEK(VARPTR(Tile(2)) + Offset)
			IF Col THEN DQBboxf 1, ((Dx - 1) * 8) + 1, ((Dy - 1) * 8) + 1, ((Dx - 1) * 8) + 8, ((Dy - 1) * 8) + 8, Col
			IF Grid THEN DQBbox 1, ((Dx - 1) * 8) + 1, ((Dy - 1) * 8) + 1, ((Dx - 1) * 8) + 8, ((Dy - 1) * 8) + 8, CWHITE
		NEXT Dx
	NEXT Dy
	DEF SEG
	DQBbox 1, 0, 0, 193, 193, CHWHITE
	CurOffs = (CurX - 1) + 24 * (CurY - 1)
	DQBbox 1, 220, 0, 245, 25, CHWHITE
	SELECT CASE DrwFlag
		CASE 0 TO 1: RELsprite 1, 221, 1, VARSEG(Tile(0)), VARPTR(Tile(0))
		CASE 2 TO 3: RELspriteTrans 1, 221, 1, VARSEG(Tile(0)), VARPTR(Tile(0))
	END SELECT
	DrawPointer 1, ((CurX - 1) * 8) + 1, ((CurY - 1) * 8) + 1, 8

	' Mouse handling
	IF ControlMode = 2 THEN
		' Drawing routines for mouse mode
		IF DQBmouseX > 0 AND DQBmouseX < 193 THEN
			IF DQBmouseY > 0 AND DQBmouseY < 193 THEN
				' Calculate cursor position
				CurX = (DQBmouseX + 7) \ 8
				CurY = (DQBmouseY + 7) \ 8
				' Plot pixel
				IF DQBmouseLB THEN
					SetPixel CurX, CurY, CurCol
					DQBsetMouseRange 1, 1, 192, 192
					Changed = TRUE
				ELSE
					DQBsetMouseRange 0, 0, 319, 199
				END IF
				' Get current color under cursor
				IF DQBmouseRB THEN CurCol = GetPixel(CurX, CurY)
			END IF
		END IF
		' Color select
		Index = 0
		IF DQBmouseX > 220 AND DQBmouseX < 285 THEN
			IF DQBmouseY > 50 AND DQBmouseY < 115 THEN
				ColX = ((DQBmouseX - 220) + 3) \ 4
				ColY = ((DQBmouseY - 50) + 3) \ 4
				Index = (ColY - 1) + 16 * (ColX - 1)
				Red = ASC(MID$(AnimePal, (3 * Index) + 1, 1))
				Grn = ASC(MID$(AnimePal, (3 * Index) + 2, 1))
				Blu = ASC(MID$(AnimePal, (3 * Index) + 3, 1))
				DQBprint 1, "R:" + LTRIM$(STR$(Red)), 220, 117, CHWHITE
				DQBprint 1, "G:" + LTRIM$(STR$(Grn)), 240, 117, CHWHITE
				DQBprint 1, "B:" + LTRIM$(STR$(Blu)), 260, 117, CHWHITE
				IF DQBmouseLB THEN CurCol = Index
			END IF
		END IF
	END IF

	' Handle user input
	' Editor keys
	IF ShiftState = 0 THEN  ' Cursor movement
		IF Press$ = CHR$(0) + "H" AND CurY > 1 THEN CurY = CurY - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF Press$ = CHR$(0) + "P" AND CurY < 24 THEN CurY = CurY + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF Press$ = CHR$(0) + "K" AND CurX > 1 THEN CurX = CurX - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF Press$ = CHR$(0) + "M" AND CurX < 24 THEN CurX = CurX + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
	ELSE ' Color select
		IF Press$ = CHR$(0) + "H" AND CurCol > 0 THEN CurCol = CurCol - 1
		IF Press$ = CHR$(0) + "P" AND CurCol < 255 THEN CurCol = CurCol + 1
		IF Press$ = CHR$(0) + "K" AND CurCol > 15 THEN CurCol = CurCol - 16
		IF Press$ = CHR$(0) + "M" AND CurCol < 240 THEN CurCol = CurCol + 16
		Red = ASC(MID$(AnimePal, (3 * CurCol) + 1, 1))
		Grn = ASC(MID$(AnimePal, (3 * CurCol) + 2, 1))
		Blu = ASC(MID$(AnimePal, (3 * CurCol) + 3, 1))
		DQBprint 1, "R:" + LTRIM$(STR$(Red)), 220, 117, CHWHITE
		DQBprint 1, "G:" + LTRIM$(STR$(Grn)), 240, 117, CHWHITE
		DQBprint 1, "B:" + LTRIM$(STR$(Blu)), 260, 117, CHWHITE
	END IF
	IF Press$ = CHR$(0) + "<" THEN   ' Flip tile vertically
		Temp(0, 0) = 0
		FOR CopyY = 1 TO 24: FOR CopyX = 1 TO 24
			Temp(CopyX, CopyY) = GetPixel(CopyX, CopyY)
		NEXT CopyX: NEXT CopyY
		DataY = 1
		FOR PasteY = 24 TO 1 STEP -1
			FOR PasteX = 1 TO 24
				SetPixel PasteX, PasteY, Temp(PasteX, DataY)
			NEXT PasteX
			DataY = DataY + 1
		NEXT PasteY
		Changed = TRUE
	END IF
	IF Press$ = CHR$(0) + ";" THEN   ' Flip tile horizontally
		Temp(0, 0) = 0
		FOR CopyY = 1 TO 24: FOR CopyX = 1 TO 24
			Temp(CopyX, CopyY) = GetPixel(CopyX, CopyY)
		NEXT CopyX: NEXT CopyY
		DataX = 1
		FOR PasteY = 1 TO 24
			FOR PasteX = 24 TO 1 STEP -1
				SetPixel PasteX, PasteY, Temp(DataX, PasteY)
				DataX = DataX + 1
			NEXT PasteX
			DataX = 1
		NEXT PasteY
		Changed = TRUE
	END IF
	IF Press$ = "H" THEN ' Change hit flag
		NewVal$ = InputBox$("Enter hit flag (0-255)", "0123456789", LTRIM$(RTRIM$(STR$(HitFlag))), 3, 1, 2, 0)
		IF VAL(NewVal$) > 255 THEN
			Msgbox VIDEO, "Invalid flag number!"
			WHILE INKEY$ = "": WEND
		ELSEIF NewVal$ <> "" THEN
			HitFlag = VAL(NewVal$)
			Changed = TRUE
		END IF
	END IF
	IF Press$ = "D" THEN ' Change draw flag
		NewVal$ = InputBox$("Enter draw flag (0-255)", "0123456789", LTRIM$(RTRIM$(STR$(DrwFlag))), 3, 1, 2, 0)
		IF VAL(NewVal$) > 255 THEN
			Msgbox VIDEO, "Invalid flag number!"
			WHILE INKEY$ = "": WEND
		ELSEIF NewVal$ <> "" THEN
			DrwFlag = VAL(NewVal$)
			Changed = TRUE
		END IF
	END IF
	IF Press$ = "-" THEN ' Change animation mode/reduce frame count
		IF AnmF = 0 THEN
			Anim = Anim + 1
			IF Anim > 3 THEN Anim = 0
			Changed = TRUE
		ELSE
			AnmF = AnmF - 1
			Changed = TRUE
		END IF
	END IF
	IF Press$ = "+" AND AnmF < 255 AND Anim THEN ' Increase frame count
		AnmF = AnmF + 1
		Changed = TRUE
	END IF
	OldTile = CurTile
	IF Press$ = CHR$(14) THEN GOSUB NewSet
	IF Press$ = CHR$(12) THEN GOSUB LoadSet
	IF Press$ = CHR$(19) THEN GOSUB ChangeTile: GOSUB SaveSet
	IF Press$ = "A" AND Anim > 0 AND AnmF > 0 THEN GOSUB ChangeTile: GOSUB TestTile
	IF Press$ = "V" THEN GOSUB ChangeTile: GOSUB PickTile: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
	IF Press$ = CHR$(0) + "Q" AND CurTile < 255 THEN CurTile = CurTile + 1: GOSUB ChangeTile
	IF Press$ = CHR$(0) + "I" AND CurTile > 0 THEN CurTile = CurTile - 1: GOSUB ChangeTile
	IF Press$ = "G" THEN Grid = Grid + 1 AND 1
	' Drawing keys
	IF Press$ = "U" THEN ' Import tile from image
		GOSUB ImportFromImage
		DQBsetMouseRange 0, 0, 319, 199
		OldMouseX = DQBmouseX
		OldMouseY = DQBmouseY
	END IF
	IF Press$ = CHR$(21) AND ImageFile$ <> "" THEN
		GOSUB ReimportFromImage
		DQBsetMouseRange 0, 0, 319, 199
		OldMouseX = DQBmouseX
		OldMouseY = DQBmouseY
	END IF
	IF Press$ = " " THEN SetPixel CurX, CurY, CurCol: Changed = TRUE
	IF Press$ = CHR$(9) THEN CurCol = GetPixel(CurX, CurY)
	IF Press$ = "T" THEN Trail = Trail + 1 AND 1
	IF Trail THEN SetPixel CurX, CurY, CurCol: Changed = TRUE
	IF Press$ = "B" THEN GOSUB DrawBox: DQBsetMouseRange 0, 0, 319, 199: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
	IF Press$ = "C" THEN                ' Change color under cursor to current
		ChangeCol = GetPixel(CurX, CurY)
		IF ShiftStat = 0 THEN   ' Seamless change
			FOR Cy = 1 TO 24: FOR cx = 1 TO 24
				IF GetPixel(cx, Cy) = ChangeCol THEN SetPixel cx, Cy, CurCol
			NEXT cx: NEXT Cy
			Changed = TRUE
		ELSE ' Random change
			FOR Cy = 1 TO 24: FOR cx = 1 TO 24
				Chg = INT(RND * 20)
				IF Chg = 10 AND GetPixel(cx, Cy) = ChangeCol THEN SetPixel cx, Cy, CurCol
			NEXT cx: NEXT Cy
			Changed = TRUE
		END IF
	END IF
	IF Press$ = "M" THEN                ' Copy whole tile
		Temp(0, 0) = -2
		FOR Cy = 1 TO 24: FOR cx = 1 TO 24
			Temp(cx, Cy) = GetPixel(cx, Cy)
		NEXT cx: NEXT Cy
		Temp(1, 0) = Anim
		Temp(2, 0) = AnmF
		Temp(3, 0) = HitFlag
		Temp(4, 0) = DrwFlag
		Temp(5, 0) = AnimRate
		SOUND 2000, 1
	END IF
	IF Press$ = "P" THEN                ' Paste
		IF ShiftState = 0 THEN
			IF Temp(0, 0) = -1 THEN       ' Paste section solidly
				DataX = 1: DataY = 1
				FOR Py = CurY TO CurY + Temp(0, 2)
					FOR Px = CurX TO CurX + Temp(0, 1)
						IF Px < 25 AND Py < 25 THEN SetPixel Px, Py, Temp(DataX, DataY)
						DataX = DataX + 1
					NEXT Px
					DataX = 1
					DataY = DataY + 1
				NEXT Py
				Changed = TRUE
			ELSEIF Temp(0, 0) = -2 THEN   ' Paste tile
				FOR Py = 1 TO 24: FOR Px = 1 TO 24
					SetPixel Px, Py, Temp(Px, Py)
				NEXT Px: NEXT Py
				Anim = Temp(1, 0)
				AnmF = Temp(2, 0)
				HitFlag = Temp(3, 0)
				DrwFlag = Temp(4, 0)
				AnimRate = Temp(5, 0)
				Changed = TRUE
			ELSE
				SOUND 100, 1
			END IF
		ELSE
			IF Temp(0, 0) = -1 THEN       ' Paste section transparently
				DataX = 1: DataY = 1
				FOR Py = CurY TO CurY + Temp(0, 2)
					FOR Px = CurX TO CurX + Temp(0, 1)
						IF Px < 25 AND Py < 25 AND Temp(DataX, DataY) THEN SetPixel Px, Py, Temp(DataX, DataY)
						DataX = DataX + 1
					NEXT Px
					DataX = 1
					DataY = DataY + 1
				NEXT Py
				Changed = TRUE
			ELSEIF Temp(0, 0) = -2 THEN   ' Paste tile
				FOR Py = 1 TO 24: FOR Px = 1 TO 24
					IF Temp(Px, Py) THEN SetPixel Px, Py, Temp(Px, Py)
				NEXT Px: NEXT Py
				Anim = Temp(1, 0)
				AnmF = Temp(2, 0)
				HitFlag = Temp(3, 0)
				DrwFlag = Temp(4, 0)
				AnimRate = Temp(5, 0)
				Changed = TRUE
			ELSE
				SOUND 100, 1
			END IF
		END IF
	END IF
	IF Press$ = "/" AND (GetPixel(CurX, CurY) MOD 16) > 0 THEN ' Decrease color shade
		ShadeCol = GetPixel(CurX, CurY)
		ShadeCol = ShadeCol - 1
		SetPixel CurX, CurY, ShadeCol
		Changed = TRUE
	END IF
	IF Press$ = "*" AND (GetPixel(CurX, CurY) MOD 16) < 15 THEN  ' Increase color shade
		ShadeCol = GetPixel(CurX, CurY)
		ShadeCol = ShadeCol + 1
		SetPixel CurX, CurY, ShadeCol
		Changed = TRUE
	END IF
	IF Press$ = "S" THEN    ' Shift tile
		Msgbox VIDEO, "Shift way? (use arrow keys)"
		DO
			P$ = INKEY$
			IF P$ = CHR$(27) THEN Dir = 0: EXIT DO
			IF P$ = CHR$(0) + "H" THEN Dir = 1: EXIT DO
			IF P$ = CHR$(0) + "P" THEN Dir = 2: EXIT DO
			IF P$ = CHR$(0) + "K" THEN Dir = 3: EXIT DO
			IF P$ = CHR$(0) + "M" THEN Dir = 4: EXIT DO
		LOOP
		SELECT CASE Dir
			CASE 1
				FOR ry = 1 TO 24: FOR rx = 1 TO 24
					Temp(rx, ry - 1) = GetPixel(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 1 TO 23: FOR rx = 1 TO 24
					SetPixel rx, ry, Temp(rx, ry)
				NEXT rx: NEXT ry
				FOR rx = 1 TO 24: SetPixel rx, 24, Temp(rx, 0): NEXT
				Temp(0, 0) = 0
				Changed = TRUE
			CASE 2
				FOR ry = 24 TO 1 STEP -1: FOR rx = 1 TO 24
					Temp(rx, ry + 1) = GetPixel(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 2 TO 24: FOR rx = 1 TO 24
					SetPixel rx, ry, Temp(rx, ry)
				NEXT rx: NEXT ry
				FOR rx = 1 TO 24: SetPixel rx, 1, Temp(rx, 25): NEXT
				Temp(0, 0) = 0
				Changed = TRUE
			CASE 3
				FOR ry = 1 TO 24: FOR rx = 1 TO 24
					Temp(rx - 1, ry) = GetPixel(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 1 TO 24: FOR rx = 1 TO 23
					SetPixel rx, ry, Temp(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 1 TO 24: SetPixel 24, ry, Temp(0, ry): NEXT
				Temp(0, 0) = 0
				Changed = TRUE
			CASE 4
				FOR ry = 1 TO 24: FOR rx = 24 TO 1 STEP -1
					Temp(rx + 1, ry) = GetPixel(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 1 TO 24: FOR rx = 2 TO 24
					SetPixel rx, ry, Temp(rx, ry)
				NEXT rx: NEXT ry
				FOR ry = 1 TO 24: SetPixel 1, ry, Temp(25, ry): NEXT
				Temp(0, 0) = 0
				Changed = TRUE
		END SELECT
	END IF

	' Print stats
	IF Trail THEN DQBprint 1, "Trail ON", 220, 130, CHWHITE ELSE DQBprint 1, "Trail OFF", 220, 130, CHWHITE
	DQBprint 1, "X:" + STR$(CurX), 220, 140, CHWHITE
	DQBprint 1, "Y:" + STR$(CurY), 245, 140, CHWHITE
	DQBprint 1, "Color:" + STR$(CurCol), 220, 146, CHWHITE
	DQBprint 1, "Tile:" + RTRIM$(STR$(CurTile)) + "/255", 220, 152, CHWHITE
	DQBprint 1, "Hit flag:" + STR$(HitFlag), 220, 170, CHWHITE
	DQBprint 1, "Draw flag:" + STR$(DrwFlag), 220, 176, CHWHITE
	SELECT CASE Anim
		CASE 0: Anim$ = "NoAnm:"
		CASE 1: Anim$ = "Oscii:"
		CASE 2: Anim$ = "AnmFD:"
		CASE 3: Anim$ = "AnmBK:"
	END SELECT
	DQBprint 1, Anim$ + STR$(AnmF), 220, 182, CHWHITE
	IF ControlMode = 2 THEN DrawCursor 1, CYELLOW
	IF ControlMode = 1 THEN
		IF DQBmouseX <> OldMouseX THEN ControlMode = 2
		IF DQBmouseY <> OldMouseY THEN ControlMode = 2
	END IF

	DQBcopyLayer 1, VIDEO
	DQBwait 1

LOOP UNTIL Press$ = CHR$(27)
Msgbox VIDEO, "Are you sure you want to quit? <Y/N>"
DO
	P$ = UCASE$(INKEY$)
	IF P$ = "Y" GOTO EndIt
	IF P$ = "N" GOTO MainLoop
LOOP
EndIt:
GOSUB ChangeTile
IF SetChanged THEN
	Msgbox VIDEO, "Save set? <Y/N>"
	DO
		P$ = UCASE$(INKEY$)
		IF P$ = "Y" THEN GOSUB SaveSet: EXIT DO
		IF P$ = "N" THEN EXIT DO
	LOOP
END IF
DQBclose
END

NewSet:
	Msgbox VIDEO, "Create new set? <Y/N>"
	DO
		P$ = UCASE$(INKEY$)
		IF P$ = "Y" THEN EXIT DO
		IF P$ = "N" THEN RETURN
	LOOP
	Test(0) = 24 * 8
	Test(1) = 24
	DEF SEG = VARSEG(Test(2))
	FOR Cy = 1 TO 24
		FOR cx = 1 TO 24
			Offs = (cx - 1) + 24 * (Cy - 1)
			POKE VARPTR(Test(2)) + Offs, 0
		NEXT cx
	NEXT Cy
	DEF SEG
	FOR ClearTile = 0 TO 255
		DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * ClearTile, TileSize
		TileAnim(ClearTile) = 0
		TileFlag(ClearTile) = 0
		AnimRate(ClearTile) = 0
	NEXT ClearTile
	SetFile$ = ""
	Changed = FALSE
	SetChanged = FALSE
	GOSUB ChangeTile
RETURN

LoadSet:
	File$ = FileSelect$("TILESETS\*.STS", "Sakura Tileset", "Load tileset", 1, 2)
	IF File$ = "" THEN RETURN
	File$ = "TILESETS\" + File$
	OPEN File$ FOR BINARY AS #1
	IF INPUT$(4, 1) <> "STS1" THEN
		Msgbox VIDEO, "Invalid tileset file!"
		WHILE INKEY$ = "": WEND
		CLOSE #1
		RETURN
	END IF
	Msgbox VIDEO, "Loading..."
	Test(0) = 24 * 8
	Test(1) = 24
	FOR ReadTile = 0 TO 255
		GET #1, , TileAnim(ReadTile)
		GET #1, , TileFlag(ReadTile)
		AnimRate(ReadTile) = ASC(INPUT$(1, 1))
		DEF SEG = VARSEG(Test(2))
		FOR ry = 1 TO 24
			Buffer$ = INPUT$(24, 1)
			FOR rx = 1 TO 24
				Byte = ASC(MID$(Buffer$, rx, 1))
				POKE VARPTR(Test(2)) + (rx - 1) + 24 * (ry - 1), Byte
			NEXT rx
		NEXT ry
		DEF SEG
		DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * ReadTile, TileSize
	NEXT ReadTile
	CLOSE #1
	DQBpeek VARSEG(Tile(0)), VARPTR(Tile(0)), CLNG(TileSize) * CurTile, TileSize
	AnimRate = AnimRate(CurTile)
	GetAnim Anim, AnmF, CurTile
	GetFlags HitFlag, DrwFlag, CurTile
	SetFile$ = File$
	SetChanged = FALSE
	Changed = FALSE
RETURN

SaveSet:
	IF SetFile$ = "" THEN
		Valid$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_"
		SetFile$ = InputBox("New tileset file name", Valid$, "", 8, 1, 2, 1)
		IF SetFile$ = "" THEN RETURN
		SetFile$ = "TILESETS\" + SetFile$ + ".STS"
		IF NOT FileNotFound(SetFile$) THEN
			Msgbox VIDEO, "File already exists! Overwrite? <Y/N>"
			DO
				P$ = UCASE$(INKEY$)
				IF P$ = "N" THEN SetFile$ = "": RETURN
				IF P$ = "Y" THEN EXIT DO
			LOOP
			KILL SetFile$
		END IF
	END IF
	Msgbox VIDEO, "Saving..."
	OPEN SetFile$ FOR BINARY AS #1
	Hdr$ = "STS1"
	PUT #1, , Hdr$
	FOR WriteTile = 0 TO 255
		Dat$ = MKI$(TileAnim(WriteTile)) + MKI$(TileFlag(WriteTile))
		Dat$ = Dat$ + CHR$(AnimRate(WriteTile))
		PUT #1, , Dat$
		DQBpeek VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * WriteTile, TileSize
		DEF SEG = VARSEG(Test(2))
		Buffer$ = ""
		FOR Wy = 1 TO 24
			FOR Wx = 1 TO 24
				Byte = PEEK(VARPTR(Test(2)) + (Wx - 1) + 24 * (Wy - 1))
				Buffer$ = Buffer$ + CHR$(Byte)
			NEXT Wx
		NEXT Wy
		PUT #1, , Buffer$
		DEF SEG
	NEXT WriteTile
	CLOSE #1
	SetChanged = FALSE
RETURN

ImportFromImage:
	ImageFile$ = FileSelect("*.BMP", "Bitmap image", "Import Image", 1, 2)
	IF ImageFile$ = "" THEN ImageFile$ = FileSelect("*.PCX", "PCX image", "Import Image", 1, 2)
	IF ImageFile$ = "" THEN RETURN
ReimportFromImage:
	DQBclearLayer 2
	IF DQBloadImage(2, 0, 0, ImageFile$, ImagePal, 0, 0) THEN
		Msgbox VIDEO, "I cannot load " + ImageFile$ + "!"
		WHILE INKEY$ = "": WEND
		RETURN
	END IF
	DQBsetPal ImagePal
	DQBsetMouseRange 0, 0, 296, 176
	DO
		P$ = INKEY$
		IF P$ = CHR$(27) THEN DQBsetPal AnimePal: RETURN
		IF DQBmouseY > 0 AND P$ = CHR$(0) + "H" THEN DQBsetMousePos DQBmouseX, DQBmouseY - 1
		IF DQBmouseY < 179 AND P$ = CHR$(0) + "P" THEN DQBsetMousePos DQBmouseX, DQBmouseY + 1
		IF DQBmouseX > 0 AND P$ = CHR$(0) + "K" THEN DQBsetMousePos DQBmouseX - 1, DQBmouseY
		IF DQBmouseX < 299 AND P$ = CHR$(0) + "M" THEN DQBsetMousePos DQBmouseX + 1, DQBmouseY
		IF DQBmouseY > 23 AND P$ = "8" THEN DQBsetMousePos DQBmouseX, DQBmouseY - 24
		IF DQBmouseY < 168 AND P$ = "2" THEN DQBsetMousePos DQBmouseX, DQBmouseY + 24
		IF DQBmouseX > 23 AND P$ = "4" THEN DQBsetMousePos DQBmouseX - 24, DQBmouseY
		IF DQBmouseX < 280 AND P$ = "6" THEN DQBsetMousePos DQBmouseX + 24, DQBmouseY
		DQBcopyLayer 2, 1
		Ix = DQBmouseX
		Iy = DQBmouseY
		xBox 1, Ix, Iy, Ix + 23, Iy + 23
		DQBcopyLayer 1, VIDEO
	LOOP UNTIL P$ = CHR$(13)
	DQBget 2, Ix, Iy, Ix + 23, Iy + 23, VARSEG(Tile(0)), VARPTR(Tile(0))
	' Convert image colors to current palette
	FOR Cy = 1 TO 24
		FOR cx = 1 TO 24
			Offs = (cx - 1) + 24 * (Cy - 1)
			DEF SEG = VARSEG(Tile(2))
			Pix = PEEK(VARPTR(Tile(2)) + Offs)
			Red = ASC(MID$(ImagePal, (3 * Pix) + 1))
			Grn = ASC(MID$(ImagePal, (3 * Pix) + 2))
			Blu = ASC(MID$(ImagePal, (3 * Pix) + 3))
			Pix = DQBfindPalCol(AnimePal, Red, Grn, Blu)
			POKE VARPTR(Tile(2)) + Offs, Pix
			DEF SEG
		NEXT cx
	NEXT Cy
	DQBsetPal AnimePal
	Changed = TRUE
RETURN

PickTile:
	FOR SelY = 1 TO 25
		FOR SelX = 1 TO 12
			Index = (SelX - 1) + 12 * (SelY - 1)
			IF Index = CurTile THEN EXIT FOR
		NEXT SelX
		IF Index = CurTile THEN EXIT FOR
	NEXT SelY
	SwapStep = 0
	DO
		P$ = UCASE$(INKEY$)
		DQBclearLayer 1
		Tx = 1
		Ty = (CamY - CamY * 2) + 1
		Index = 0
		FOR Dy = 1 TO 25
			FOR Dx = 1 TO 12
				DQBpeek VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
				RELsprite 1, Tx, Ty, VARSEG(Test(0)), VARPTR(Test(0))
				DQBprint 1, LTRIM$(STR$(Index)), Tx + 2, Ty + 2, CHWHITE
				IF ControlMode = 2 THEN
					IF DQBmouseX > Tx AND DQBmouseX < Tx + 24 THEN
						IF DQBmouseY > Ty AND DQBmouseY < Ty + 24 THEN
							SelX = Dx
							SelY = Dy
						END IF
					END IF
				END IF
				Tx = Tx + 25
				Index = Index + 1
				IF Index > 255 THEN EXIT FOR
			NEXT Dx
			Tx = 1
			Ty = Ty + 25
			IF Index > 255 THEN EXIT FOR
		NEXT Dy
		Index = (SelX - 1) + 12 * (SelY - 1)
				
		IF P$ = CHR$(0) + "H" AND SelY > 1 THEN SelY = SelY - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "P" AND SelY < 22 THEN SelY = SelY + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "K" AND SelX > 1 THEN SelX = SelX - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "M" AND SelX < 12 THEN SelX = SelX + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF DQBmouseX <> OldMouseX OR DQBmouseY <> OldMouseY THEN ControlMode = 2
		IF ControlMode = 2 THEN
			DrawCursor 1, CYELLOW
			IF DQBmouseLB THEN EXIT DO
		END IF

		IF Index > 255 THEN SelX = 4: SelY = 22
		' Tile manipulation keys
		IF P$ = "S" THEN  ' Swap tile
			IF SwapStep = 0 THEN       ' Set tile to swap with a different tile
				TileToSwap = Index
				SwapStep = SwapStep + 1
				SOUND 1000, 1
			ELSEIF SwapStep = 1 THEN   ' Swap the tiles
				' Swap the tiles
				DQBpeek VARSEG(SBuf(0)), VARPTR(SBuf(0)), CLNG(TileSize) * TileToSwap, TileSize
				DQBpeek VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
				DQBpoke VARSEG(SBuf(0)), VARPTR(SBuf(0)), CLNG(TileSize) * Index, TileSize
				DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * TileToSwap, TileSize
				' Swap the tile flags and stuff
				SWAP TileFlag(TileToSwap), TileFlag(Index)
				SWAP TileAnim(TileToSwap), TileAnim(Index)
				SWAP AnimRate(TileToSwap), AnimRate(Index)
				SwapStep = 0
				SetChanged = TRUE
			END IF
		END IF
		IF P$ = "M" THEN  ' Copy tile
			DQBpeek VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
			Temp(0, 0) = -2
			DEF SEG = VARSEG(Test(2))
			FOR Dy = 1 TO 24
				FOR Dx = 1 TO 24
					Offs = (Dx - 1) + 24 * (Dy - 1)
					Temp(Dx, Dy) = PEEK(VARPTR(Test(2)) + Offs)
				NEXT Dx
			NEXT Dy
			DEF SEG
			GetAnim Anim, AnmF, Index
			GetFlags HitFlag, DrwFlag, Index
			Temp(1, 0) = Anim
			Temp(2, 0) = AnmF
			Temp(3, 0) = HitFlag
			Temp(4, 0) = DrwFlag
			Temp(5, 0) = AnimRate(Index)
			SOUND 2000, 1
		END IF
		IF P$ = "P" THEN  ' Paste tile
			IF ShiftState = 0 THEN  ' Solid paste
				IF Temp(0, 0) = -2 THEN
					Test(0) = 24 * 8
					Test(1) = 24
					DEF SEG = VARSEG(Test(2))
					FOR Dy = 1 TO 24
						FOR Dx = 1 TO 24
							Offs = (Dx - 1) + 24 * (Dy - 1)
							Byte = Temp(Dx, Dy)
							POKE VARPTR(Test(2)) + Offs, Byte
						NEXT Dx
					NEXT Dy
					DEF SEG
					DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
					SetAnim Temp(1, 0), Temp(2, 0), Index
					SetFlags Temp(3, 0), Temp(4, 0), Index
					AnimRate(Index) = Temp(5, 0)
					SetChanged = TRUE
				ELSE
					SOUND 100, 1
				END IF
			ELSE  ' Transparent paste
				IF Temp(0, 0) = -2 THEN
					Test(0) = 24 * 8
					Test(1) = 24
					DEF SEG = VARSEG(Test(2))
					FOR Dy = 1 TO 24
						FOR Dx = 1 TO 24
							Offs = (Dx - 1) + 24 * (Dy - 1)
							Byte = Temp(Dx, Dy)
							IF Byte THEN POKE VARPTR(Test(2)) + Offs, Byte
						NEXT Dx
					NEXT Dy
					DEF SEG
					DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
					SetAnim Temp(1, 0), Temp(2, 0), Index
					SetFlags Temp(3, 0), Temp(4, 0), Index
					AnimRate(Index) = Temp(5, 0)
					SetChanged = TRUE
				ELSE
					SOUND 100, 1
				END IF
			END IF
		END IF
		IF P$ = CHR$(0) + "S" THEN ' Delete tile
			Test(0) = 24 * 8
			Test(1) = 24
			DEF SEG = VARSEG(Test(2))
			FOR Dy = 1 TO 24
				FOR Dx = 1 TO 24
					Offs = (Dx - 1) + 24 * (Dy - 1)
					POKE VARPTR(Test(2)) + Offs, 0
				NEXT Dx
			NEXT Dy
			DEF SEG
			DQBpoke VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * Index, TileSize
			TileAnim(Index) = 0
			TileFlag(Index) = 0
			AnimRate(Index) = 0
			SetChanged = TRUE
		END IF
		DQBsbox 1, 25 * (SelX - 1), (25 * (SelY - 1)) - CamY, (25 * (SelX - 1)) + 25, ((25 * (SelY - 1)) + 25) - CamY, CYELLOW
		DQBcopyLayer 1, VIDEO
		DQBwait 1
		FOR Scroll = 1 TO 20
			IF (25 * (SelY - 1)) + 12 < (CamY + 100) - 10 * Scroll THEN CamY = CamY - 1: IF ControlMode = 2 THEN DQBsetMousePos DQBmouseX, DQBmouseY + 1
			IF (25 * (SelY - 1)) + 12 > (CamY + 100) + 10 * Scroll THEN CamY = CamY + 1: IF ControlMode = 2 THEN DQBsetMousePos DQBmouseX, DQBmouseY - 1
		NEXT Scroll
		IF P$ = CHR$(27) THEN RETURN
	LOOP UNTIL P$ = CHR$(13)
	IF ControlMode = 2 THEN WHILE DQBmouseLB: WEND
	OldTile = CurTile
	CurTile = (SelX - 1) + 12 * (SelY - 1)
	GOSUB ChangeTile
RETURN

TestTile:
	Frame = 0
	AnimDir = 1
	AnimCnt = 1
	OldRate = AnimRate
	DO
		P$ = UCASE$(INKEY$)
		DQBcopyLayer 3, 1
		DQBpeek VARSEG(Test(0)), VARPTR(Test(0)), CLNG(TileSize) * (CurTile + Frame), TileSize
		SELECT CASE DrwFlag
			CASE 0 TO 1: RELsprite 1, 160 - 12, 100 - 12, VARSEG(Test(0)), VARPTR(Test(0))
			CASE 2 TO 3: RELspriteTrans 1, 160 - 12, 100 - 12, VARSEG(Test(0)), VARPTR(Test(0))
		END SELECT
		
		DQBprint 1, "Count:" + LTRIM$(STR$(AnimCnt)), 145, 120, CHWHITE
		DQBprint 1, "Frame:" + LTRIM$(STR$(Frame)), 145, 126, CHWHITE
		DQBprint 1, "Rate:" + LTRIM$(STR$(AnimRate)), 145, 132, CHWHITE
		DQBcopyLayer 1, VIDEO
		DQBwait 1
		AnimCnt = AnimCnt + 1
		IF AnimCnt > AnimRate THEN
			SELECT CASE Anim
				CASE 1
					IF Frame = 0 THEN AnimDir = 1
					IF Frame = AnmF THEN AnimDir = -1
					Frame = Frame + AnimDir
				CASE 2
					Frame = Frame + 1
					IF Frame > AnmF THEN Frame = 0
				CASE 3
					Frame = Frame - 1
					IF Frame < (AnmF - AnmF * 2) THEN Frame = 0
			END SELECT
			AnimCnt = 1
		END IF
		IF P$ = "+" AND AnimRate < 255 THEN AnimRate = AnimRate + 1
		IF P$ = "-" AND AnimRate > 1 THEN AnimRate = AnimRate - 1
		IF P$ = CHR$(27) THEN AnimRate = OldRate: RETURN
	LOOP UNTIL P$ = CHR$(13)
	Changed = TRUE
RETURN

DrawBox:
	XStep = 1
	YStep = 1
	PointX = CurX
	PointY = CurY
	DQBcopyLayer 1, 2
	DrawPointer 2, ((CurX - 1) * 8) + 1, ((CurY - 1) * 8) + 1, 8
	DQBsetMouseRange 1, 1, 192, 192
	DO
		P$ = UCASE$(INKEY$)
		DQBcopyLayer 2, 1
		IF CurY > PointY THEN YStep = 1
		IF CurY < PointY THEN YStep = -1
		IF CurX > PointX THEN XStep = 1
		IF CurX < PointX THEN XStep = -1
		FOR Dy = PointY TO CurY STEP YStep
			DrawPointer 1, ((PointX - 1) * 8) + 1, ((Dy - 1) * 8) + 1, 8
			IF PointX <> CurX THEN DrawPointer 1, ((CurX - 1) * 8) + 1, ((Dy - 1) * 8) + 1, 8
		NEXT Dy
		IF XStep > 0 THEN
			FOR Dx = PointX + 1 TO CurX - 1 STEP XStep
				DrawPointer 1, ((Dx - 1) * 8) + 1, ((PointY - 1) * 8) + 1, 8
				IF PointY <> CurY THEN DrawPointer 1, ((Dx - 1) * 8) + 1, ((CurY - 1) * 8) + 1, 8
			NEXT Dx
		ELSE
			FOR Dx = PointX - 1 TO CurX + 1 STEP XStep
				DrawPointer 1, ((Dx - 1) * 8) + 1, ((PointY - 1) * 8) + 1, 8
				IF PointY <> CurY THEN DrawPointer 1, ((Dx - 1) * 8) + 1, ((CurY - 1) * 8) + 1, 8
			NEXT Dx
		END IF
		IF P$ = "M" THEN  ' Copy section
			IF CurX > PointX THEN StartX = PointX: EndX = CurX
			IF CurX < PointX THEN StartX = CurX: EndX = PointX
			IF CurY > PointY THEN StartY = PointY: EndY = CurY
			IF CurY < PointY THEN StartY = CurY: EndY = PointY
			Temp(0, 0) = -1
			Temp(0, 1) = EndX - StartX
			Temp(0, 2) = EndY - StartY
			DataX = 1: DataY = 1
			FOR Cy = StartY TO EndY
				FOR cx = StartX TO EndX
					Temp(DataX, DataY) = GetPixel(cx, Cy)
					DataX = DataX + 1
				NEXT cx
				DataX = 1
				DataY = DataY + 1
			NEXT Cy
			SOUND 2000, 1
			RETURN
		END IF
		IF P$ = "X" THEN  ' Cut section
			IF CurX > PointX THEN StartX = PointX: EndX = CurX
			IF CurX < PointX THEN StartX = CurX: EndX = PointX
			IF CurY > PointY THEN StartY = PointY: EndY = CurY
			IF CurY < PointY THEN StartY = CurY: EndY = PointY
			Temp(0, 0) = -1
			Temp(0, 1) = EndX - StartX
			Temp(0, 2) = EndY - StartY
			DataX = 1: DataY = 1
			FOR Cy = StartY TO EndY
				FOR cx = StartX TO EndX
					Temp(DataX, DataY) = GetPixel(cx, Cy)
					SetPixel cx, Cy, CurCol
					DataX = DataX + 1
				NEXT cx
				DataX = 1
				DataY = DataY + 1
			NEXT Cy
			Changed = TRUE
			SOUND 2000, 1
			RETURN
		END IF
		IF ControlMode = 2 THEN
			CurX = (DQBmouseX + 7) \ 8
			CurY = (DQBmouseY + 7) \ 8
			DrawCursor 1, CYELLOW
			IF DQBmouseLB THEN EXIT DO
		END IF
		IF P$ = CHR$(0) + "H" AND CurY > 1 THEN CurY = CurY - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "P" AND CurY < 24 THEN CurY = CurY + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "K" AND CurX > 1 THEN CurX = CurX - 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF P$ = CHR$(0) + "M" AND CurX < 24 THEN CurX = CurX + 1: ControlMode = 1: OldMouseX = DQBmouseX: OldMouseY = DQBmouseY
		IF DQBmouseX <> OldMouseX OR DQBmouseY <> OldMouseY THEN ControlMode = 2
		IF P$ = CHR$(27) THEN RETURN
		DQBcopyLayer 1, VIDEO
		DQBwait 1
	LOOP UNTIL P$ = " "
	WHILE DQBmouseLB: WEND
	IF ShiftState = 0 THEN  ' Draw hollow box
		FOR Dy = PointY TO CurY STEP YStep: FOR Dx = PointX TO CurX STEP XStep
			SetPixel PointX, Dy, CurCol
			SetPixel Dx, PointY, CurCol
			SetPixel CurX, Dy, CurCol
			SetPixel Dx, CurY, CurCol
		NEXT Dx: NEXT Dy
	ELSE  ' Draw filled box
		FOR Dy = PointY TO CurY STEP YStep: FOR Dx = PointX TO CurX STEP XStep
			SetPixel Dx, Dy, CurCol
		NEXT Dx: NEXT Dy
	END IF
	Changed = TRUE
RETURN

ChangeTile:
	IF Changed THEN   ' Confirm to save changes
		Msgbox VIDEO, "Save changes? <Y/N>"
		DO
			P$ = UCASE$(INKEY$)
			IF P$ = "Y" THEN SaveIt = TRUE: EXIT DO
			IF P$ = "N" THEN SaveIt = FALSE: EXIT DO
		LOOP
		IF SaveIt THEN
			DQBpoke VARSEG(Tile(0)), VARPTR(Tile(0)), CLNG(TileSize) * OldTile, TileSize
			AnimRate(OldTile) = AnimRate
			SetAnim Anim, AnmF, OldTile
			SetFlags HitFlag, DrwFlag, OldTile
			IF SetFile$ <> "" THEN SetChanged = TRUE
		END IF
		Changed = FALSE
	END IF
	DQBpeek VARSEG(Tile(0)), VARPTR(Tile(0)), CLNG(TileSize) * CurTile, TileSize
	AnimRate = AnimRate(CurTile)
	GetAnim Anim, AnmF, CurTile
	GetFlags HitFlag, DrwFlag, CurTile
RETURN

REM $STATIC
SUB DrawPointer (Layer, X, Y, Size)

FOR Dy = Y TO Y + (Size - 1)
	FOR Dx = X TO X + (Size - 1)
		Col = DQBpoint(Layer, Dx, Dy) XOR 255
		DQBpset Layer, Dx, Dy, Col
	NEXT Dx
NEXT Dy

END SUB

SUB GetAnim (Anim, AnmF, Tile)

DEF SEG = VARSEG(TileAnim(Tile))
Anim = PEEK(VARPTR(TileAnim(Tile)))
AnmF = PEEK(VARPTR(TileAnim(Tile)) + 1)
DEF SEG

END SUB

SUB GetFlags (HitFlag, DrwFlag, Tile)

DEF SEG = VARSEG(TileFlag(Tile))
HitFlag = PEEK(VARPTR(TileFlag(Tile)))
DrwFlag = PEEK(VARPTR(TileFlag(Tile)) + 1)
DEF SEG

END SUB

FUNCTION GetPixel (X, Y)

DEF SEG = VARSEG(Tile(2))
Offset = (X - 1) + 24 * (Y - 1)
GetPixel = PEEK(VARPTR(Tile(2)) + Offset)
DEF SEG

END FUNCTION

SUB SetAnim (Anim, AnmF, Tile)

DEF SEG = VARSEG(TileAnim(Tile))
POKE VARPTR(TileAnim(Tile)), Anim
POKE VARPTR(TileAnim(Tile)) + 1, AnmF
DEF SEG

END SUB

SUB SetFlags (HitFlag, DrwFlag, Tile)

DEF SEG = VARSEG(TileFlag(Tile))
POKE VARPTR(TileFlag(Tile)), HitFlag
POKE VARPTR(TileFlag(Tile)) + 1, DrwFlag
DEF SEG

END SUB

SUB SetPixel (X, Y, Col)

DEF SEG = VARSEG(Tile(2))
Offset = (X - 1) + 24 * (Y - 1)
POKE VARPTR(Tile(2)) + Offset, Col
DEF SEG

END SUB

FUNCTION ShiftState

DEF SEG = 0: KeyState = PEEK(&H417): DEF SEG
IF (KeyState AND 7) = 0 THEN ShiftState = 0
IF (KeyState AND 3) > 0 THEN ShiftState = 1

END FUNCTION

